#ifndef LINKEDLIST_2D
#define LINKEDLIST_2D

#include "node.h"
#include "node.cpp" //use .cpp only if it contains templates.

template <class T>
class linkedlist_2d{
    private:
        NODE< NODE<T>* > *base_head;
        NODE< NODE<T>* > *base_tail; 
        void append_row();
        bool append_col(int row, T data);

    public:
        linkedlist_2d();
        ~linkedlist_2d();  
        void append(int row, const T data);    
    	bool get_data(int row, int col, T& data);
    	bool update_data(int row, int col, const T data);
        bool remove_data(int row, int col);
        void print();
    	void erase();
};


#endif 
