#ifndef NODE_H
#define NODE_H


template <class T>
struct NODE {
   NODE<T> *pNext;
   NODE<T> *pPrev;
   T nData;
};

template <class T>
void AppendNode(NODE<T> * pNode, NODE<T> **pHead, NODE<T> **pTail);

template <class T>
void InsertNode(NODE<T> *pNode, NODE<T> *pAfter, NODE<T> **pTail);

template <class T>
void InsertNodeAt(NODE<T> *pNode, NODE<T> *pAfter, NODE<T> **pHead);

template <class T>
void RemoveNode(NODE<T> *pNode, NODE<T> **pHead, NODE<T> **pTail);

template <class T>
void DeleteAllNodes(NODE<T> **pHead, NODE<T> **pTail);


#endif 
